﻿/***
 * 
 * @param msg Message to display
 * @param type warning, danger, success
 * @param parent Parent Element
 * @returns Prepared Message
 */
function showMsg(msg, type, parent)
{
	type	= type || 'warning';

	var message	=  '<div class="alert alert-' + type + '">';
		message	+= '	<button type="button" class="close" data-dismiss="alert">&times;</button>';
		message	+= msg;
		message	+= '</div>';

	if (parent)
	{
		parent.html(message);
		setTimeout(function(){
			return true;
			//parent.html("");
		}, 3000);
	}
	return message;
}
function Login(data)
{
	var self	= this;

	data	= data || {};

	data.email	= data.email || "";

	self.email		= ko.observable(data.email).extend({ required:true, email:true, maxLength:80 });
	self.password	= ko.observable("").extend({ required:true, minLength:6, maxLength:12 });
	self.username	= ko.observable(data.username || "");
	self.isEmail	= ko.observable((self.username() == ""));

	self.showEmail	= function(){
		self.isEmail(true);
		$('#redirect_url').val('');
		$("#email").select();
	};

	if (self.email())
	{
		$('#password').select();
	}

	self.onSubmit	= function(item, elem){
		var msgs	= '';

		// Some time browser remember will auto fill the form,
		// so the value in KO object may not update,
		// so here manually update the value using jQuery.
		self.email($("#email").val());
		if (!self.email.isValid())
		{
			msgs	+= data.lang["EMAIL_FIELD_REQUIRED"];
		}

		self.password($("#password").val());
		if (!self.password.isValid())
		{
			if (self.password().length)
			{
				msgs	+= data.lang["PASSWORD_MIN_LENGTH_REQUIRED"];
			}
			else
			{
				msgs	+= data.lang["PASSWORD_FIELD_REQUIRED"];
			}
		}
		if (msgs != "")
		{
			showMsg(msgs, 'danger', $("#alert_message"));
			return false;
		}

		return true;
	};

	return self;
}
function Entity_register(data)
{
	var self	= this;

	data	= data || {};

	self.company_name	= ko.observable(data.company_name || "").extend({required:true, minLength:5, maxLength:60});
//	self.domain_url		= ko.observable("").extend({required:true, minLength:4, maxLength:16});
	self._subdom		= ko.observable("");
	self.user_name		= ko.observable(data.user_name || "").extend({required:true, minLength:4, maxLength:60});
	self.email			= ko.observable(data.email || "").extend({required:true, email:true, maxLength:80});
	self.confirm_email	= ko.observable("").extend({required:true, email:true, maxLength:80});
	self.password		= ko.observable("").extend({required:true, minLength:6, maxLength:12});
	self.confirm_password= ko.observable("").extend({required:true, minLength:6, maxLength:12});

	/*self.domain_url.subscribe(function(newVal){
		$('#domain').removeClass();
		if(newVal!='') 
		{
			$.post("home/checkdomain/" + newVal, function(resp){
				self._subdom("");
				if (resp[0] && Object.keys(resp[2]).length)
				{
					resp	= resp[2];
					self._subdom(resp._subdom);
					$('#domain').addClass('input-group-addon icon-ok');
				}
				else if(resp[1])
				{
					$('#domain').addClass('input-group-addon icon-remove');
				}
			});
		}
	});*/

	self.isValid	= function(){
		var msgs	= "";
		if (self.company_name().length > 0 && self.company_name().length < 5  )
		{
			msgs	+= data.lang["COMPANY_LENGTH"]+'<br>';
		}
		else if (!self.company_name.isValid())
		{
			msgs	+= data.lang["COMPANY_REQUIRED"]+'<br>';
		}
		/*if (self.domain_url().length > 0 && self.domain_url().length < 4  )
		{
			msgs	+= data.lang["SUBDOMAIN_LENGTH"]+'<br>';
		}
		else if (!self.domain_url.isValid())
		{
			msgs	+= data.lang["SUBDOMAIN_NAME_REQUIRED"]+'<br>';
		}
		if (self.domain_url() && $.trim(self._subdom()) == "" )
		{
			msgs	+= data.lang["SUBDOMAIN_NAME_NOT_YET_VERIFIED"]+'<br>';
		}*/
		if (self.user_name().length > 0 && self.user_name().length < 4  )
		{
			msgs	+= data.lang["ADMIN_NAME_LENGTH"]+'<br>';
		}
		else if (!self.user_name.isValid())
		{
			msgs	+= data.lang["ADMIN_NAME_REQUIRED"]+'<br>';
		}
		if (!self.email.isValid())
		{
			msgs	+= data.lang["INVALID_EMAIL"]+'<br>';
		}
		if (!self.confirm_email.isValid())
		{
			msgs	+= data.lang["INVALID_EMAIL"]+'<br>';
		}
		if (self.confirm_email() && self.confirm_email() != self.email())
		{
			msgs	+= data.lang["CONFIRM_EMAIL_DIFFERENT"]+'<br>';
		}
		if (self.password().length > 0 && self.password().length < 6  )
		{
			msgs	+= data.lang["ADMIN_PASSWORD_LENGTH"]+'<br>';
		}
		else if (!self.password.isValid())
		{
			msgs	+= data.lang["ADMIN_PASSWORD_REQUIRED"]+'<br>';
		}
		if (self.password() && !self.confirm_password())
		{
			msgs	+= data.lang["CONFIRM_PASSWORD_REQUIRED"]+'<br>';
		}
		if (self.confirm_password() && self.confirm_password() != self.password())
		{
			msgs	+= data.lang["CONFIRM_PASSWORD_DIFFERENT"]+'<br>';
		}

		if(msgs != '')
		{
			showMsg(msgs, 'danger', $("#alert_message"));
			return false;
		}

		return true;
	};

	self.onSubmit	= function(item, element){
		if (!self.isValid())
		{
			return false;
		}
		return true;
	};
}

function Signup(data)
{
	var self	= this;
	data	= data || {};

	self.company_name	= ko.observable("").extend({required:true, minLength:5, maxLength:60});
	self.domain_url		= ko.observable("").extend({required:true, minLength:4, maxLength:16});
	self._subdom		= ko.observable("");
	self.user_name		= ko.observable("").extend({required:true, minLength:4, maxLength:60});
	self.email			= ko.observable("").extend({required:true, email:true, maxLength:80});
	self.password		= ko.observable("").extend({required:true, minLength:6, maxLength:12});
	self.confirm_password= ko.observable("").extend({required:true, minLength:6, maxLength:12});

	self.domain_url.subscribe(function(newVal){
		$('#domain').removeClass();
		if(newVal!='') 
		{
			$.post(window.site_url+"home/checkdomain/" + newVal, function(resp){
				self._subdom("");
				if (resp[0] && Object.keys(resp[2]).length)
				{
					resp	= resp[2];
					self._subdom(resp._subdom);
					$('#domain').addClass('input-group-addon icon-ok');
				}
				else if(resp[1])
				{
					$('#domain').addClass('input-group-addon icon-remove');
				}
			});
		}
	});

	if (data.domain_url) {
		self.domain_url(data.domain_url.substring(0, data.domain_url.lastIndexOf(".")));
	}

	self.isValid	= function(){
		var msgs	= "";
		if (self.company_name().length > 0 && self.company_name().length < 5  )
		{
			msgs	+= data.lang["COMPANY_LENGTH"]+'<br>';
		}
		else if (!self.company_name.isValid())
		{
			msgs	+= data.lang["COMPANY_REQUIRED"]+'<br>';
		}
		if (self.domain_url().length > 0 && self.domain_url().length < 4  )
		{
			msgs	+= data.lang["SUBDOMAIN_LENGTH"]+'<br>';
		}
		else if (!self.domain_url.isValid())
		{
			msgs	+= data.lang["SUBDOMAIN_NAME_REQUIRED"]+'<br>';
		}
		if (self.domain_url() && $.trim(self._subdom()) == "" )
		{
			msgs	+= data.lang["SUBDOMAIN_NAME_NOT_YET_VERIFIED"]+'<br>';
		}
		if (self.user_name().length > 0 && self.user_name().length < 4  )
		{
			msgs	+= data.lang["ADMIN_NAME_LENGTH"]+'<br>';
		}
		else if (!self.user_name.isValid())
		{
			msgs	+= data.lang["ADMIN_NAME_REQUIRED"]+'<br>';
		}
		if (!self.email.isValid())
		{
			msgs	+= data.lang["INVALID_EMAIL"]+'<br>';
		}
		if (self.password().length > 0 && self.password().length < 6  )
		{
			msgs	+= data.lang["ADMIN_PASSWORD_LENGTH"]+'<br>';
		}
		else if (!self.password.isValid())
		{
			msgs	+= data.lang["ADMIN_PASSWORD_REQUIRED"]+'<br>';
		}
		if (self.password() && !self.confirm_password())
		{
			msgs	+= data.lang["CONFIRM_PASSWORD_REQUIRED"]+'<br>';
		}
		if (self.confirm_password() && self.confirm_password() != self.password())
		{
			msgs	+= data.lang["CONFIRM_PASSWORD_DIFFERENT"]+'<br>';
		}

		if(msgs != '')
		{
			showMsg(msgs, 'danger', $("#alert_message"));
			return false;
		}

		return true;
	};

	self.onSubmit	= function(item, element){
		if (!self.isValid())
		{
			return false;
		}
		return true;
	};
}
function Reset(data)
{
	var self	= this;

	data	= data || {};

	self.email	= ko.observable("").extend({required:true, email:true, maxLength:80});

	self.onSubmit	= function(item){
		if (!self.email.isValid())
		{
			showMsg("Invalid email.", "danger", $("#alert_message"));
			return false;
		}
		return true;
	};

	return self;
}

function ForgotDomainConfirm(data)
{
	var self	= this;

	data	= data || {};

	self.email	= ko.observable("").extend({required:true, email:true, maxLength:80});

	self.onSubmit	= function(item){
		var msg	= '';
		self.email($("#email").val());
		if (!self.email.isValid())
		{
			msg	+= "Invalid email." + "</br>";
		}
		
		if (msg)
		{
			showMsg(msg, "danger", $("#alert_message"));
			return false;
		}

		return true;
	};

	return self;
}

function ResetConfirm(data)
{
	var self	= this;

	data	= data || {};

	self.email	= ko.observable("").extend({required:true, email:true, maxLength:80});
	self.verification_code	= ko.observable("").extend({required:true, maxLength:80});

	self.onSubmit	= function(item){
		var msg	= '';
		self.email($("#email").val());
		if (!self.email.isValid())
		{
			msg	+= "Invalid email." + "</br>";
		}
		if (!self.verification_code.isValid())
		{
			msg	+= "Verification Code required." + "</br>";
		}

		if (msg)
		{
			showMsg(msg, "danger", $("#alert_message"));
			return false;
		}

		return true;
	};

	return self;
}
function ResetComplete(data)
{
	var self	= this;

	data	= data || {};

	self.password		= ko.observable("").extend({required:true, maxLength:80});
	self.confirm_password	= ko.observable("").extend({required:true, maxLength:80});

	self.onSubmit	= function(item){
		var msg	= '';
		if (!self.password.isValid())
		{
			msg	+= "Password required." + "</br>";
		}
		if (!self.confirm_password.isValid())
		{
			msg	+= "Confirm password required." + "</br>";
		}
		if (self.password() != self.confirm_password())
		{
			msg	+= "Password not match with confirm password." + "</br>";
		}
		if (msg)
		{
			showMsg(msg, "danger", $("#alert_message"));
			return false;
		}

		return true;
	};

	return self;
}
